<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class PageRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule( 'pages' ) )
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'image'=> 'required'
        ];

        foreach (languages() as $lang) {
            $lang_rules=
            [
                'title_'.$lang->local=> 'required|min:3|max:500',
                'items.*.name_'.$lang->local=> 'required|min:3|max:500',
            ];

            $rules= array_merge($rules, $lang_rules);
        }
        if(in_array($this->page->id ,[1,2,3,7,11,13,14,15]))
        {
            foreach (languages() as $lang) {
                $lang_rules=
                    [
                        'description_'.$lang->local => 'required|min:3|max:1000',
                    ];

                $rules= array_merge($rules, $lang_rules);
            }
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('pages');
        $attributes=[
            'image'=>__('pages.image'),
            ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local=>  __('pages.title').' '.$lang->local,
                'slug_'.$lang->local=>  $field[$lang->local]['slug'] ?? __('pages.slug'),
                'keywords_'.$lang->local=> $field[$lang->local]['keywords'] ?? __('pages.keywords'),
                'meta_description_'.$lang->local=> $field[$lang->local]['meta_description'] ?? __('pages.meta_description'),
                'description_'.$lang->local=>  __('pages.description').' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }

        $items = request('items');
        if($items)
        {
            $serial = 1;
            foreach($items as $key=>$row)
            {

                foreach (languages() as $lang)
                {
                    $lang_attributes = [
                        'items.' . $key . '.name_' . $lang->local =>  __('items.name') . ' ' . $lang->local . ' ' . $serial,
                    ];
                    $attributes = array_merge($attributes, $lang_attributes);
                }
                $serial += 1;
            }
        }
        return $attributes;
    }
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
